%define		date 20180726
#define		git a131b99
%define		bdir %{version}
%define		ndpiver 4.14

%define rel	1

Summary:	A next generation Network and traffic analyzer
Name:		ntopng
Version:	6.4
Release:	%mkrel %{?git:0.git%{?date:%date}.}%{rel}
License:	GPLv3
Group:		Monitoring
URL:		https://www.ntop.org/
Source0:	https://github.com/ntop/ntopng/archive/%{bdir}/%{name}-%{version}%{?git:-%{?date:%date}-%{?git:%git}}.tar.gz
Source1:	ntopng.conf
Source2:	ntopng.service
Source3:	ntopng.sysconfig
Source4:	ntopng.tmpfiles.d
Patch1:		ntopng-6.4-dev-pidfile.patch
Patch2:		ntopng-6.4-shared-libndpi.patch
Patch3:		ntopng-6.4-system-lua.patch
BuildRequires:	bison
BuildRequires:	cairo-devel
BuildRequires:	clang
BuildRequires:	clang-devel
BuildRequires:	flex
BuildRequires:	GeoIP-devel
BuildRequires:	pkgconfig(hiredis)
BuildRequires:	libpcap-devel
BuildRequires:	libtool
BuildRequires:	mariadb-devel
BuildRequires:	netfilter_conntrack-devel
BuildRequires:	netfilter_queue-devel
BuildRequires:	pango-devel
BuildRequires:	pkgconfig(expat)
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(json-c)
BuildRequires:	pkgconfig(libcap)
BuildRequires:	pkgconfig(libcurl)
BuildRequires:	pkgconfig(libndpi) >= %{ndpiver}
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libxml-2.0)
BuildRequires:	pkgconfig(libzstd)
BuildRequires:	pkgconfig(netsnmp)
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pkgconfig(sqlite3)
BuildRequires:	pkgconfig(libmaxminddb)
BuildRequires:	redis >= 4.0.7
BuildRequires:	rrdtool-devel
BuildRequires:	zeromq-devel >= 3.2.4
BuildRequires:	pkgconfig(zlib)
BuildRequires:	lua-devel
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1
Requires:	tcp_wrappers
Requires:	rrdtool
Requires:	geoip
Requires:	redis >= 5.0.0
Requires:	pkgconfig(openssl)
Obsoletes:	ntop < 5.0.1-11

%description
ntopng is the next generation version of the original ntop.
It is a network packet traffic probe and collector that renders
network usage graphically, similar to what the popular top Unix
command does. It is based on libpcap and it has been written in a
portable way in order to virtually run on every Unix platform and on
Windows as well.

ntopng is easy to use and suitable for monitoring enterprise network
environments. A web browser is used to navigate through ntopng's
rendered web pages for viewing current traffic information and/or to
get a data dump of the collected network network status and statistics.
In the latter case, ntopng can be seen as a simple RMON-like agent with
an embedded web interface.

ntopng feature highlights:

* An intuitive web interface sporting numerous visuals and monitoring graphs.
* Show network traffic and IPv4/IPv6 active hosts.
* Analyse IP traffic and sort it according to the source/destination.
* Limited configuration and administration via the web interface.
* Reduced CPU and memory usage (this varies according to network size and
  traffic).
* Collection of a large number of hosts and network statistic values.
* Discover application protocols by leveraging nDPI (i.e., ntop’s Deep Packet
  Inspection Library).
* Report IP protocol usage sorted by protocol type.

%prep
%autosetup -p1 -n %{name}-%{bdir}

#use system libs
rm -rf third-party/{lua-5*,hiredis,json-c,rrdtool*,zeromq*}

%build
export CC=clang
export CXX=clang++
export GIT_DISCOVERY_ACROSS_FILESYSTEM=1
export LDFLAGS="%build_ldflags -Wl,--build-id=sha1"
./autogen.sh --noconfig

%serverbuild

%configure \
    --bindir=%{_sbindir} \
    --localstatedir=/var/lib \
    --with-ndpi=%{_libdir} \
    --with-ndpi-includes=%{_includedir}/ndpi/

%make_build

%install

install -d %{buildroot}%{_datadir}/ntopng
install -d %{buildroot}%{_mandir}/man8
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_sysconfdir}/%{name}
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_unitdir}

install -m0755 ntopng %{buildroot}%{_sbindir}
install -m0644 ntopng.8 %{buildroot}%{_mandir}/man8

cp -ar httpdocs %{buildroot}%{_datadir}/%{name}
cp -ar scripts %{buildroot}%{_datadir}/%{name}

# fix broken symlinks
rm -rf  %{buildroot}%{_datadir}/ntopng/scripts/lua/modules/{resty,i18n}
cp -ar third-party/lua-resty-template-master/lib/resty third-party/i18n.lua-master/i18n \
        %{buildroot}%{_datadir}/ntopng/scripts/lua/modules/

find %{buildroot}%{_datadir}/%{name} -name "*~"   | xargs rm -f
find %{buildroot}%{_datadir}/%{name} -name ".svn" | xargs rm -rf
find %{buildroot}%{_datadir}/%{name} -name ".git" | xargs rm -rf

install -d %{buildroot}%{_localstatedir}/lib/%{name}/rrd/{flows,graphics,interfaces}

install -m0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/%{name}/%{name}.conf
install -m0644 %{SOURCE2} %{buildroot}%{_unitdir}/%{name}.service
install -m0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/%{name}

# fix permissions
find %{buildroot}%{_datadir}/%{name}/httpdocs -type f -print0|xargs -0 chmod 644
find %{buildroot}%{_datadir}/%{name}/httpdocs -type d -print0|xargs -0 chmod 755

# dangling symlinks
rm -rf %{buildroot}%{_datadir}/%{name}/httpdocs/geoip
ln -s %{_datadir}/GeoIP %{buildroot}%{_datadir}/%{name}/httpdocs/geoip
ln -s %{_sysconfdir}/pki/tls/private/%{name}.pem %{buildroot}%{_datadir}/%{name}/httpdocs/ssl/%{name}-cert.pem

mkdir -p %{buildroot}%{_tmpfilesdir}
install -m 0644 %{SOURCE4} %{buildroot}%{_tmpfilesdir}/%{name}.conf

%pretrans -p <lua>
-- Define the path to the symlink being replaced below.
path = "/usr/share/ntopng/scripts/lua/modules/resty"
st = posix.stat(path)
if st and st.type == "link" then
  os.remove(path)
end
path = "/usr/share/ntopng/scripts/lua/modules/i18n"
st = posix.stat(path)
if st and st.type == "link" then
  os.remove(path)
end

%pre
%_pre_useradd %{name} %{_localstatedir}/lib/%{name} /bin/false

%post
%_post_service ntopng
%_create_ssl_certificate ntopng -b
chown ntopng:ntopng %{_sysconfdir}/pki/tls/private/ntopng.pem

%_tmpfilescreate %{_tmpfilesdir}/%{name}

%preun
%_preun_service ntopng

%files
%doc doc/README*
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%{_unitdir}/%{name}.service
%{_sbindir}/%{name}
%{_mandir}/man8/%{name}.8.*
%{_datadir}/%{name}/
%{_tmpfilesdir}/%{name}.conf
%attr(0750,ntopng,ntopng) %dir %{_localstatedir}/lib/%{name}


%changelog
* Mon May 19 2025 daviddavid <daviddavid> 6.4-1.mga10
+ Revision: 2184874
- new version: 6.4

* Fri Mar 29 2024 daviddavid <daviddavid> 4.2-8.mga10
+ Revision: 2053068
- rebuild for new hiredis 1.2.0

* Sat Apr 16 2022 pterjan <pterjan> 4.2-7.mga9
+ Revision: 1850788
- Try fixing the build on arm

* Sat Apr 02 2022 umeabot <umeabot> 4.2-6.mga9
+ Revision: 1841164
- Mageia 9 Mass Rebuild

* Sat Oct 02 2021 wally <wally> 4.2-5.mga9
+ Revision: 1747929
- rebuild for openssl 3.0.0

* Sun Apr 04 2021 wally <wally> 4.2-4.mga9
+ Revision: 1713090
- add patch for proper linking

* Sun Apr 04 2021 wally <wally> 4.2-3.mga9
+ Revision: 1713086
- add patch to build with system lua

* Thu Jan 28 2021 daviddavid <daviddavid> 4.2-2.mga8
+ Revision: 1673788
- uglify-js no more available in mga8

* Sat Dec 26 2020 neoclust <neoclust> 4.2-1.mga8
+ Revision: 1663814
- New version 4.2 (mga#27756)

* Sun Nov 29 2020 luigiwalser <luigiwalser> 3.8-4.mga8
+ Revision: 1650345
- rebuild for json-c

* Thu Jan 16 2020 wally <wally> 3.8-3.mga8
+ Revision: 1480053
- replace deprecated %%configure2_5x

* Tue Apr 16 2019 daviddavid <daviddavid> 3.8-3.mga7
+ Revision: 1391151
- rebuild for new llvm/clang 8.0

* Tue Feb 26 2019 kekepower <kekepower> 3.8-2.mga7
+ Revision: 1370231
- Use /run instead of /var/run

* Sun Dec 23 2018 kekepower <kekepower> 3.8-1.mga7
+ Revision: 1344728
- Update to version 3.8

* Fri Nov 30 2018 wally <wally> 3.6.1-3.mga7
+ Revision: 1336940
- revert r1336595 changes in shared libndpi patch as 'libndpi.so not found' was fixed in libndpi

* Wed Nov 28 2018 kekepower <kekepower> 3.6.1-2.mga7
+ Revision: 1336595
- Fix shared-libs patch to use correct library (mga#23920)

* Mon Oct 08 2018 pterjan <pterjan> 3.6.1-1.mga7
+ Revision: 1318595
- Build embedded luajit before trying to link with it
- Update ndpi path
- Update to 3.6.1
+ daviddavid <daviddavid>
- Update to 3.5-20180726-gita131b99
- rebuild for new json-c 0.13.1
+ kekepower <kekepower>
- Update to 3.5-20180427-git9058187

* Tue Apr 03 2018 kekepower <kekepower> 3.3-0.git20180403.1.mga7
+ Revision: 1215000
- Update to git20180403-9889c29
- Rediffed patch

* Tue Mar 13 2018 kekepower <kekepower> 3.3-0.git20180313.1.mga7
+ Revision: 1209086
- Rediffed ntopng-3.3-dev-ntop-running-user.patch
- Update to 20180313-a595267

* Thu Mar 01 2018 kekepower <kekepower> 3.3-0.git20180301.1.mga7
+ Revision: 1205876
- Update to git20180301-a870426
- Added BR for libzstd

* Wed Feb 21 2018 kekepower <kekepower> 3.3-0.git20180221.1.mga7
+ Revision: 1204003
- Update to git20180221-f8d7677

* Mon Feb 12 2018 kekepower <kekepower> 3.3-0.git20180212.1.mga7
+ Revision: 1200725
- Update to git-20180212
- Safely remove symlinks from previous build when upgrading
+ wally <wally>
- don't ship /var/run/ntopng as it's created by systemd-tmpfiles

* Mon Feb 12 2018 wally <wally> 3.3-0.git20180206.3.mga7
+ Revision: 1200694
- build with libcap

* Mon Feb 12 2018 wally <wally> 3.3-0.git20180206.2.mga7
+ Revision: 1200687
- don't pkg entire third-party source dir
- provide bundled(luajit) as modified luajit is used
- add patch to build with shared libndpi

* Tue Feb 06 2018 kekepower <kekepower> 3.3-0.git20180206.1.mga7
+ Revision: 1199333
- Update to git20180206-53d2505

* Sat Feb 03 2018 kekepower <kekepower> 3.3-0.git20180202.3.mga7
+ Revision: 1198671
- Rebuild for arm

* Sat Feb 03 2018 kekepower <kekepower> 3.3-0.git20180202.2.mga7
+ Revision: 1198666
- Update to 3.3 git-f37b071
- Rediffed patches
- Updated BR's

* Wed Jan 31 2018 kekepower <kekepower> 2.4-1.mga7
+ Revision: 1198266
- Update to version 2.4
- Rediffed patches for the new version
- Added a few extra BR's
- General cleanup in the spec file

* Sat Jan 27 2018 kekepower <kekepower> 2.0-8.mga7
+ Revision: 1197361
- Rebuild against new redis

* Sat Oct 07 2017 daviddavid <daviddavid> 2.0-7.mga7
+ Revision: 1169821
- patch3: fix build with gcc7

* Sat May 07 2016 luigiwalser <luigiwalser> 2.0-6.mga6
+ Revision: 1010331
- obsolete ntop

* Sat May 07 2016 daviddavid <daviddavid> 2.0-5.mga6
+ Revision: 1010295
- rebuild for rrdtool 1.6.0

* Sun Mar 06 2016 blino <blino> 2.0-4.mga6
+ Revision: 986401
- rebuild for armv5tl

* Tue Feb 16 2016 umeabot <umeabot> 2.0-3.mga6
+ Revision: 961772
- Mageia 6 Mass Rebuild

* Thu Nov 12 2015 oden <oden> 2.0-2.mga6
+ Revision: 902700
- fix deps

* Wed Nov 11 2015 oden <oden> 2.0-1.mga6
+ Revision: 902556
- fix sloppy paste
- fix non-ghost-in-var-run
- fix rpmlint error
- fix deps (curl-devel)
- 2.0
- rediff patches
- added one patch from debian
- imported package ntopng

